// Modified or written by Ex Machina SAGL for inclusion with lambdaj.
// Copyright (c) 2009 Mario Fusco, Luca Marrocco.
// Licensed under the Apache License, Version 2.0 (the "License")

package ch.lambdaj.proxy;

import java.lang.reflect.*;
import java.lang.reflect.InvocationHandler;

import net.sf.cglib.proxy.*;

/**
 * An intercptor that seamlessly manages invocations on both a native Java proxy and a cglib one.
 * @author Mario Fusco
 */
public abstract class InvocationInterceptor implements MethodInterceptor, InvocationHandler {

	public interface VoidInterceptor { }
	
	public static final InvocationInterceptor VOID = new InvocationInterceptor() {
		public Object invoke(Object arg0, Method arg1, Object[] arg2) throws Throwable {
			return null;
		}
	};
	
	public final Object intercept(Object proxy, Method method, Object[] args, MethodProxy methodProxy) throws Throwable {
		return invoke(proxy, method, args);
	}
}
